Skip to main content

Brute Force - Question 2

2105. Watering Plants II

Alice and Bob want to water n plants in their garden. The plants are arranged in a row and are labeled from 0 to n - 1 from left to right where the ith plant is located at x = i.


Each plant needs a specific amount of water. Alice and Bob have a watering can each, initially full. They water the plants in the following way:


Alice waters the plants in order from left to right, starting from the 0th plant. Bob waters the plants in order from right to left, starting from the (n - 1)th plant. They begin watering the plants simultaneously.

It takes the same amount of time to water each plant regardless of how much water it needs.

Alice/Bob must water the plant if they have enough in their can to fully water it. Otherwise, they first refill their can (instantaneously) then water the plant.

In case both Alice and Bob reach the same plant, the one with more water currently in his/her watering can should water this plant. If they have the same amount of water, then Alice should water this plant.

Given a 0-indexed integer array plants of n integers, where plants[i] is the amount of water the ith plant needs, and two integers capacityA and capacityB representing the capacities of Alice's and Bob's watering cans respectively, return the number of times they have to refill to water all the plants.


Constraints:


n == plants.length

1 <= n <= 10^5

1 <= plants[i] <= 10^6

max(plants[i]) <= capacityA, capacityB <= 10^9


Analysis:

This question can be solved directly, or brute force, with a time complexity of O(N), where N is the number of the plants.

One of the key constrains here is the time to water one plant is the same. So we can just water the plant one by one from both ends, and we need to make sure them move simultaneously. 

Before the two persons meet, the logic is the same. So we can just consider one side.

Let pick up the left side. One the water can is empty, or does not have enough water for the plant, we just need to refill it.

When the two person meet:

1. this is the last plant to be plant;

2. if one of them having cans with more water than that is needed for the plant, then that plant will be watered without any more refill; otherwise, we need the final refill.


See the code below:


class Solution {
public:
    int minimumRefill(vector<int>& plants, int capacityA, int capacityB) {
        int res = 0, n = plants.size(), i = 0, j = n-1, c1 = capacityA, c2 = capacityB;
        while(i<=j) {
            if(i==j) {
                // the last one
                if(c1 < plants[i] && c2 < plants[j]) ++res;
                break;
            } else {
                if(c1 >= plants[i]) c1 -= plants[i++];
                else {
                    ++res;
                    c1 = capacityA - plants[i++];
                }
                if(c2 >= plants[j]) c2 -= plants[j--];
                else {
                    ++res;
                    c2 = capacityB - plants[j--];
                }
            }
        }
        return res;
    }
};


Follow up:

How about the amount of time to water one plant is proportional to the amount of the water needed? Or the speed of the water flowing out of the can is the same?



Upper Layer


Comments

Popular posts from this blog

Dynamic Programming - Easy Level - Question 1

Dynamic Programming - Easy Level - Question 1 Leetcode 1646  Get Maximum in Generated Array You are given an integer n. An array nums of length n + 1 is generated in the following way: nums[0] = 0 nums[1] = 1 nums[2 * i] = nums[i] when 2 <= 2 * i <= n nums[2 * i + 1] = nums[i] + nums[i + 1] when 2 <= 2 * i + 1 <= n Return the maximum integer in the array nums​​​. Constraints: 0 <= n <= 100 Analysis: This question is quick straightforward: the state and transitional formula are given; the initialization is also given. So we can just ready the code to iterate all the states and find the maximum. See the code below: class Solution { public: int getMaximumGenerated(int n) { int res = 0; if(n<2) return n; vector<int> f(n+1, 0); f[1] = 1; for(int i=2; i<=n; ++i) { if(i&1) f[i] = f[i/2] + f[i/2+1]; else f[i] = f[i/2]; // cout<<i<<" "<<f[i]<<endl; ...

Bit Manipulation - Medium Level

 Leetcode 416 Partition Equal Subset Sum Given a non-empty array nums containing only positive integers, find if the array can be partitioned into two subsets such that the sum of elements in both subsets is equal. Constraints: 1 <= nums.length <= 200 1 <= nums[i] <= 100 Analysis: There are different ways to solve this problem, such as dp with a time complexity of O(N^2). Since N is small to this question, so it is Okay to pass OJ. Besides the small N, the value of each element is also very small. So this gives us some chance to use "space to trad off time". The data structure to be used is bitset. For bitset, each bit can be either 0 or 1. The index of that bit can be used as the corresponding sum. When the bit is 1, means there is a sum with the value of its index. When a new number comes, this number needs to be added to all the previous sums, to form new "previous" sums. Thus for each number, we need to go through all the previous sums, the time co...